searchData={"items":[{"type":"module","title":"LiveReact","doc":"See READ.md for installation instructions and examples.","ref":"LiveReact.html"},{"type":"function","title":"LiveReact.react/1","doc":"Render a React component.","ref":"LiveReact.html#react/1"},{"type":"extras","title":"README","doc":"[![Hex.pm](https://img.shields.io/hexpm/v/live_react.svg)](https://hex.pm/packages/live_react)\n[![Hexdocs.pm](https://img.shields.io/badge/docs-hexdocs.pm-purple)](https://hexdocs.pm/live_react)\n[![GitHub](https://img.shields.io/github/stars/mrdotb/live_react?style=social)](https://github.com/mrdotb/live_vue)\n\n# LiveReact\n\nReact inside Phoenix LiveView.","ref":"readme.html"},{"type":"extras","title":"Features - README","doc":"- ⚡ **End-To-End Reactivity** with LiveView\n- 🦄 **Tailwind** Support\n- 💀 **Dead View** Support","ref":"readme.html#features"},{"type":"extras","title":"Resources - README","doc":"- [Demo](https://live-react-examples.fly.dev/simple)\n- [HexDocs](https://hexdocs.pm/live_react)\n- [HexPackage](https://hex.pm/packages/live_react)\n- [Phoenix LiveView](https://github.com/phoenixframework/phoenix_live_view)","ref":"readme.html#resources"},{"type":"extras","title":"Why LiveReact - README","doc":"Phoenix LiveView enables rich, real-time user experiences with server-rendered HTML.\nIt works by communicating any state changes through a websocket and updating the DOM in realtime.\nYou can get a really good user experience without ever needing to write any client side code.\n\nLiveReact builds on top of Phoenix LiveView to allow for easy client side state management while still allowing for communication over the websocket.","ref":"readme.html#why-livereact"},{"type":"extras","title":"Installation - README","doc":"1. Add `live_react` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:live_react, \"~> 0.1.0\"}\n  ]\nend\n```\n\n2. Adjust the `setup` in `mix.exs`:\n\n- For Linux/MacOs\n\n```elixir\ndefp aliases do\n    [\n      setup: [\"deps.get\", \"assets.setup\", \"npm install --prefix assets\", \"assets.build\"],\n    ]\nend\n```\n\n- For Windows\n\n```elixir\ndefp aliases do\n    [\n      setup: [\"deps.get\", \"assets.setup\", \"cmd --cd assets npm install\", \"assets.build\"],\n    ]\nend\n```\n\n3. Run the following in your terminal\n\n```bash\nmix deps.get\n```\n\n4. Add `import LiveReact` in `html_helpers/0` inside `/lib/ _web.ex` like so:\n\n```elixir\n# /lib/ _web.ex\n\ndefp html_helpers do\n  quote do\n\n    # ...\n\n    import LiveReact # <-- Add this line\n\n    # ...\n\n  end\nend\n```\n\n5. Create a package.json file at `assets/package.json`\n\n```json\n{\n  \"dependencies\": {\n    \"@mrdotb/live-react\": \"^0.1.0\",\n    \"phoenix\": \"file:../deps/phoenix\",\n    \"phoenix_html\": \"file:../deps/phoenix_html\",\n    \"phoenix_live_view\": \"file:../deps/phoenix_live_view\",\n    \"react\": \"^18.3.1\",\n    \"react-dom\": \"^18.3.1\"\n  }\n}\n```\n\n6. Create a `react` directory inside `assets` and add a `index.js` file\n\n```javascript\n// import and export the react components you want to use in your LiveView\n// ex: import { Simple } from \"./simple\";\n\n// ex: export default { Simple };\nexport default {};\n```\n\n7. Add the following to your `assets/js/app.js` file\n\n```javascript\n...\nimport components from \"../react\";\nimport { getHooks } from \"live_react\";\n\nconst hooks = {\n  ...getHooks(components),\n};\n\nlet csrfToken = document\n  .querySelector(\"meta[name='csrf-token']\")\n  .getAttribute(\"content\");\nlet liveSocket = new LiveSocket(\"/live\", Socket, {\n  hooks: hooks, // <-- pass the hooks\n  longPollFallbackMs: 2500,\n  params: { _csrf_token: csrfToken },\n});\n...\n```\n\n7. For tailwind support, make some addition to `content` in the `assets/tailwind.config.js` file\n\n```javascript\ncontent: [\n  ...\n    \"./react/**/*.jsx\", // <- if you are using jsx\n    \"./react/**/*.tsx\" // <- if you are using tsx\n],\n\n```","ref":"readme.html#installation"},{"type":"extras","title":"Examples - README","doc":"Check out the [demo website](https://live-react-examples.fly.dev/simple) on fly.io to see some examples of what you can do with LiveReact.","ref":"readme.html#examples"},{"type":"extras","title":"Credits - README","doc":"I was inspired by the following libraries:\n- [LiveVue](https://github.com/Valian/live_vue)\n- [LiveSvelte](https://github.com/woutdp/live_svelte)\n\nI had a need for a similar library for React and so I created LiveReact 👍","ref":"readme.html#credits"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}